import { ComponentFixture, TestBed, async, fakeAsync, flush, tick } from '@angular/core/testing';

import { GridComponent } from './grid.component';
import { NO_ERRORS_SCHEMA } from '@angular/core';
import { By } from '@angular/platform-browser';
import { WjGridModule } from '@grapecity/wijmo.angular2.grid';
import { WjGridFilterModule } from '@grapecity/wijmo.angular2.grid.filter';
import { FlexGrid } from '@grapecity/wijmo.grid';
import { hasClass } from '@grapecity/wijmo';


describe('GridComponent', () => {
  let component: GridComponent;
  let fixture: ComponentFixture<GridComponent>;

  beforeEach(async () => {
    await TestBed.configureTestingModule({
      declarations: [GridComponent],
      imports: [WjGridModule, WjGridFilterModule],
      schemas: [NO_ERRORS_SCHEMA]
    }).compileComponents();

    fixture = TestBed.createComponent(GridComponent);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });

  it('Flexgrid instance should be initialized', () => {
    // fixture.
    expect(component.grid).toBeTruthy();

  });
  it('Flexgrid Filter instance should be initialized', () => {
    // fixture.
    fixture.detectChanges();
    expect(component.filter).toBeTruthy();
    expect(component.filter.grid == component.grid).toBeTrue();
  });

  it('test select method of flexgrid', fakeAsync(async () => {
    fixture.detectChanges();
    const grid: FlexGrid = component.grid;

    await fixture.whenStable().then(() => {

      let rIndex = 2, cIndex = 3;
      grid.select(rIndex, cIndex);
      // get cell element
      let cell = grid.cells.getCellElement(rIndex, cIndex);
      // check if the cell is selected or not
      expect(hasClass(cell, 'wj-state-selected')).toBeTruthy();
    })
  }))

});
