import { Component, ViewChild } from '@angular/core';
import * as wjOdata from '@grapecity/wijmo.odata';
import * as wjGrid from '@grapecity/wijmo.grid';
import * as wjCore from '@grapecity/wijmo';

@Component({
  selector: 'app-grid',
  templateUrl: './grid.component.html',
  styleUrls: ['./grid.component.css']
})
export class GridComponent {
  @ViewChild('grid', { static: false }) grid: any;
  @ViewChild('filter', { static: false }) filter: any;
  // grid: any = null;
  tabsInfo: any[] = [];
  data = new wjOdata.ODataCollectionView('https://services.odata.org/Northwind/Northwind.svc/', 'Products', {
    sortOnServer: false,
  })

  // data = this.getSampleData(20);
  //
  constructor() {
  }

  flexInit(grid: wjGrid.FlexGrid) {
    // this.grid = grid;
    let cv: any = grid.collectionView;
    // cv.loaded.addHandler((s: any, e: any) => {
    //   grid.autoSizeColumns();
    // })
  }

  getSampleData(count: number) {
    // create some random data
    let countries = 'US,Germany,UK,Japan,Italy,Greece'.split(',');
    let data = [];
    for (let i = 0; i < count; i++) {
      data.push({
        id: i,
        date: new Date(2015, i % 12, (i + 1) % 25),
        time: new Date(2015, i % 12, (i + 1) % 25, i % 24, i % 60, i % 60),
        country: countries[i % countries.length],
        countryMapped: i % countries.length,
        downloads: Math.round(Math.random() * 20000),
        sales: Math.random() * 10000,
        expenses: Math.random() * 5000,
        checked: Boolean(Math.floor(Math.random() + 0.5))
      });
    }
    return data;
  }

}
